/*****************************************************************************
    types.h

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2005 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#ifndef TFTP_TYPES_H
#define TFTP_TYPES_H
/* 
	This file defines all internally needed types
*/
#define STRING(A)       #A

#define V_L     volatile

#define _GNU_SOURCE

#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif

#ifdef HAVE_LIMITS_H
#include <limits.h>
#endif

#ifdef HAVE_MEMDEBUG
#include <mcheck.h>
#define MALLOC_TRACE "malloc.trace"
#include "memtrace.h"
#define Malloc(a)    xMalloc(__FUNCTION__,__LINE__,(a))
#define Realloc(a,b) xRealloc(__FUNCTION__,__LINE__,(a),(b))
#define Free(a)      xFree(__FUNCTION__,__LINE__,(a))
#define Strdup(a)    xStrdup(__FUNCTION__,__LINE__,(a))
#define Strndup(a)   xStrndup(__FUNCTION__,__LINE__,(a))
#define Calloc(n,a)  xCalloc(__FUNCTION__,__LINE__,(n),(a))
#else
void zFree(char **p);
char *zRealloc(char **p, size_t s);
#define Malloc(a)    malloc(a)
#define Realloc(a,b) zRealloc((char **)&(a),b)
#define Free(a)      zFree((char **)&(a))
#define Strdup(a)    strdup(a)
#define Strndup(a)   strndup(a)
#define Calloc(n,a)  calloc(n,a)
#endif

#ifdef HAVE_EXECINFO_H
#ifdef HAVE_BACKTRACE
#include <execinfo.h>
#endif
#else
#ifdef HAVE_BACKTRACE
#undef HAVE_BACKTRACE
#endif
#endif

#ifndef HAVE_UCHAR
typedef	unsigned char	uchar;
#endif

#ifndef HAVE_UINT
typedef	unsigned int	uint;
#endif

#ifndef HAVE_USHORT
typedef	unsigned short	ushort;
#endif

#ifndef HAVE_ULONG
typedef	unsigned long	ulong;
#endif

#ifndef HAVE_SOCKLEN_T
#define socklen_t int
#endif

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#else
#error Mandatory header file "sys/types.h" missing
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#else
#error Mandatory header file "stdlib.h" missing
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#else
#error Mandatory header file "unistd.h" missing
#endif

#ifdef HAVE_IN_ADDR_T
#include <netinet/in.h>
#else
typedef unsigned	in_addr_t;
#endif

#ifndef HAVE_TIME_H
#error Mandatory header file "time.h" missing
#else
typedef struct timeval	tv_t;
#endif

#ifdef TIME_WITH_SYS_TIME
#include <sys/time.h>
#include <time.h>
#else
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#else
#include <time.h>
#endif
#endif


#ifdef HAVE_STRING_H
#include <string.h>
#else
#error Mandatory header file "string.h" missing
#endif

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#else
#error Mandatory header file "fcntl.h" missing
#endif

#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#ifdef HAVE_REGEX_H
#include <regex.h>
#else
#include "regex.h"
#endif

#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#else
#error Mandatory header file "syslog.h" missing
#endif

#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#else
#error Mandatory header file "sys/ioctl.h" missing
#endif

#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#else
#error Mandatory header file "sys/stat.h" missing
#endif

#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#else
#error Mandatory header file "sys/wait.h" missing
#endif

#ifdef HAVE_SYS_RESOURCE_H
#include <sys/resource.h>
#endif

#ifdef HAVE_NETINET_IN_SYSTM_H
#include <netinet/in_systm.h>
#endif

#ifndef HAVE_SOCKLEN_T
#define socklen_t int
#endif

#ifndef HAVE_ALLOCA
#error Mandatory function "alloca()" missing
#endif

#ifndef HAVE_VPRINTF
#error Mandatory function "vprintf()" missing
#endif

#ifndef HAVE_INET_ATON
#error Mandatory function "inet_aton()" missing
#endif

#ifndef HAVE_SELECT
#error Mandatory function "select()" missing
#endif

#ifndef HAVE_SIGACTION
#error Mandatory function "sigaction()" missing
#endif

#ifndef HAVE_SIGPROCMASK
#error Mandatory function "sigprocmask()" missing
#endif

#ifndef HAVE_SOCKET
#error Mandatory function "socket()" missing
#endif

#ifndef HAVE_GETTIMEOFDAY
#ifndef HAVE_FTIME
#error Both mandatory functions "gettimeofday()" and "ftime()" missing
#endif
#endif

#ifndef HAVE_STRCASECMP
#error Mandatory function "strcasecmp()" missing
#endif

#ifndef HAVE_SNPRINTF
#error Mandatory function "snprintf()" missing
#endif

#ifndef HAVE_STRNCASECMP
#error Mandatory function "strncasecmp()" missing
#endif

#ifndef HAVE_STRDUP
#error Mandatory function "Strdup()" missing
#endif

#ifndef HAVE_STRERROR
#error Mandatory function "strerror()" missing
#endif

#ifndef HAVE_STRFTIME
#error Mandatory function "strftime()" missing
#endif

#ifndef HAVE_REALPATH
#error Mandatory function "realpath()" missing
#endif

#ifndef HAVE_MACRO_FUNCTION
#define __FUNCTION__ ""
#endif

/* 
	use vfork() for spawning filters whenever possible,
	but not on linux systems (it doesn't make sense here)
*/

#if !defined(HAVE_VFORK) || defined(linux)
#define vfork()	fork()
#endif

#ifdef HAVE_LIBINTL_H
#include <locale.h>
#include <libintl.h>
#define  _(STRING) gettext (STRING)
#define  _p(STRING1,STRING2,NUM) ngettext (STRING1,STRING2,NUM)
#else
#define  _(STRING) STRING
#define  _p(STRING1,STRING2,NUM) ((NUM==1)?STRING1:STRING2)
#endif

typedef unsigned long	count_t;

typedef struct stat 	stat_t;

typedef struct regCon_s { int      pid;
                          struct   tftpR_s  *req;   } regCon_t;

#ifdef __GNUC__
#define COMPILERVERSION "GNU gcc " __VERSION__
#endif

#endif /* TFTP_TYPES_H */
